ArkInventory.LDB = {
	Bags = ArkInventory.Lib.DataBroker:NewDataObject( ArkInventory.Const.Program.Name .. "_" .. ArkInventory.Const.Slot.Data[ArkInventory.Const.Location.Bag].name, {
		type = "data source",
		icon = ArkInventory.Global.Location[ArkInventory.Const.Location.Bag].Texture,
		text = ArkInventory.Const.Slot.Data[ArkInventory.Const.Location.Bag].name,
	} ),
	Money = ArkInventory.Lib.DataBroker:NewDataObject( ArkInventory.Const.Program.Name .. "_" .. MONEY, {
		type = "data source",
		icon = [[Interface\Icons\INV_Misc_Coin_02]],
		text = "Money",
	} ),
	Companion = { },
	Pets = ArkInventory.Lib.DataBroker:NewDataObject( ArkInventory.Const.Program.Name .. "_Pet", {
		type = "data source",
		icon = ArkInventory.Global.Location[ArkInventory.Const.Location.Pet].Texture,
		text = "",
	} ),
	Mounts = ArkInventory.Lib.DataBroker:NewDataObject( ArkInventory.Const.Program.Name .. "_Mount", {
		type = "data source",
		icon = ArkInventory.Global.Location[ArkInventory.Const.Location.Mount].Texture,
		text = "",
	} ),
	Tracking_Currency = ArkInventory.Lib.DataBroker:NewDataObject( ArkInventory.Const.Program.Name .. "_Tracking_Currency", {
		type = "data source",
		icon = ArkInventory.Global.Location[ArkInventory.Const.Location.Token].Texture,
		text = "",
	} ),
	Tracking_Item = ArkInventory.Lib.DataBroker:NewDataObject( ArkInventory.Const.Program.Name .. "_Tracking_Item", {
		type = "data source",
		icon = [[Interface\Icons\Ability_Tracking]],
		text = "",
	} ),
}

function ArkInventory.LDB.Bags.OnClick( frame, button )
	if button == "RightButton" then
		ArkInventory.MenuLDBBagsOpen( frame )
	else
		ArkInventory.Frame_Main_Toggle( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.LDB.Bags:Update( )
	local loc_id = ArkInventory.Const.Location.Bag
	--ArkInventory.LDB.Bags.icon = ArkInventory.Global.Location[loc_id].Texture
	self.text = ArkInventory.Frame_Status_Update_Empty( loc_id, ArkInventory.Global.Me, true )
end



function ArkInventory.LDB.Money:Update( )
	ArkInventory.LDB.Money.text = ArkInventory.MoneyText( GetMoney( ) )
end

function ArkInventory.LDB.Money:OnTooltipShow( )
	ArkInventory.MoneyFrame_Tooltip( self )
end



function ArkInventory.LDB.Tracking_Currency:Update( )
	
	self.text = ""
	
	-- expand all token headers
	local numTokenTypes = GetCurrencyListSize( )
	
	if numTokenTypes == 0 then return end
	
	for j = numTokenTypes, 1, -1 do
		local _, isHeader, isExpanded = GetCurrencyListInfo( j )
		if isHeader and not isExpanded then
			ExpandCurrencyList( j, 1 )
		end
	end
	
	local numTracked = 0
	numTokenTypes = GetCurrencyListSize( )
	local size = ( ArkInventory.db.char.option.ldb.tracking.currency.size or 0 ) + 1
	
	for j = 1, numTokenTypes do
		
		local name, isHeader, isExpanded, isUnused, isWatched, count, currencyType, icon, item = GetCurrencyListInfo( j )
		
		if not isHeader then
			
			if ArkInventory.db.char.option.ldb.tracking.currency.tracked[name] then
				
--				if currencyType == 1 then
--					icon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]]
--				elseif currencyType == 2 then
--					icon = [[Interface\PVPFrame\PVP-Currency-]] .. UnitFactionGroup( "player" )
--				end
				
				numTracked = numTracked + 1
				size = size - 1
				self.text = string.format( "%s  |T%s:!!!:!!!|t %d", self.text, icon, count )
				
			end
			
		end
		
	end
	
	if numTracked > 0 then
		if ArkInventory.Const.TOC < 40000 then
			if size < 1 then
				size = 0
			end
			size = string.format( "%d", size )
			self.text = string.gsub( self.text, "!!!", size )
		else
			self.text = string.gsub( self.text, "!!!:!!!", "0" )
		end
	end
	
end

function ArkInventory.LDB.Tracking_Currency.OnClick( frame, button )
	if button == "RightButton" then
		ArkInventory.MenuLDBTrackingCurrencyOpen( frame )
	else
		ArkInventory.Frame_Main_Toggle( ArkInventory.Const.Location.Token )
	end
end

function ArkInventory.LDB.Tracking_Currency:OnTooltipShow( )
	
	self:AddLine( string.format( "%s: %s", ArkInventory.Localise["LDB_TRACKING"], ArkInventory.Localise["LDB_TRACKING_CURRENCY"] ) )
	
	local numTokenTypes = GetCurrencyListSize( )
	
	if numTokenTypes == 0 then return end
	
	-- expand all token headers
	for j = numTokenTypes, 1, -1 do
		local _, isHeader, isExpanded = GetCurrencyListInfo( j )
		if isHeader and not isExpanded then
			ExpandCurrencyList( j, 1 )
		end
	end
	
	numTokenTypes = GetCurrencyListSize( )
	
	for j = 1, numTokenTypes do
		
		local name, isHeader, isExpanded, isUnused, isWatched, count, currencyType, icon, item = GetCurrencyListInfo( j )
		
		if isHeader then
			self:AddLine( " " )
			self:AddLine( name )
		else
			if ArkInventory.db.char.option.ldb.tracking.currency.tracked[name] then
				self:AddDoubleLine( name, count, 0, 1, 0, 0, 1, 0 )
			else
				self:AddDoubleLine( name, count, 1, 1, 1, 1, 1, 1 )
			end
		end
		
	end
	
end



function ArkInventory.LDB.Tracking_Item:Update( )
	
	self.text = ""
	
	local numTracked = 0
	local size = ( ArkInventory.db.char.option.ldb.tracking.item.size or 0 ) + 1
	
	for k in ArkInventory.spairs( ArkInventory.db.global.option.tracking.items )  do
		
		local checked = ArkInventory.db.char.option.ldb.tracking.item.tracked[k]
		
		if checked then
			
			local count = GetItemCount( k ) or 0
			local icon = select( 10, GetItemInfo( k ) ) or missing
			
			numTracked = numTracked + 1
			size = size - 1
			self.text = string.format( "%s  |T%s:!!!:!!!|t %s", self.text, icon, count )
			
		end
		
	end
	
	if numTracked > 0 then
		if ArkInventory.Const.TOC < 40000 then
			if size < 1 then
				size = 0
			end
			size = string.format( "%d", size )
			self.text = string.gsub( self.text, "!!!", size )
		else
			self.text = string.gsub( self.text, "!!!:!!!", "0" )
		end
	end
	
end

function ArkInventory.LDB.Tracking_Item.OnClick( frame, button )
	if button == "RightButton" then
		ArkInventory.MenuLDBTrackingItemOpen( frame )
	else
		
	end
end

function ArkInventory.LDB.Tracking_Item:OnTooltipShow( )
	
	self:AddLine( string.format( "%s: %s", ArkInventory.Localise["LDB_TRACKING"], ArkInventory.Localise["LDB_TRACKING_ITEM"] ) )
	
	self:AddLine( " " )
	
	for k in ArkInventory.spairs( ArkInventory.db.global.option.tracking.items )  do
		
		local count = GetItemCount( k )
		local name = GetItemInfo( k )
		
		local checked = ArkInventory.db.char.option.ldb.tracking.item.tracked[k]
		
		if checked then
			self:AddDoubleLine( name, count, 0, 1, 0, 0, 1, 0 )
		else
			self:AddDoubleLine( name, count, 1, 1, 1, 1, 1, 1 )
		end
		
	end
	
end



function ArkInventory.LDB.Pets:Update( )
	
	self.icon = [[Interface\Icons\INV_Misc_Dice_01]]
	
	local creatureType = "CRITTER"
	
	local track = ArkInventory.db.char.option.ldb.pets.track
	
	if track then
		for k = 1, GetNumCompanions( creatureType ) do
			local creatureID, creatureName, creatureSpellID, texture, active = GetCompanionInfo( creatureType, k )
			if creatureSpellID == track then
				self.icon = texture
				return
			end
		end
		
	end
	
end

function ArkInventory.LDB.Pets:OnTooltipShow( )
	
	local creatureType = "CRITTER"
	
	local n = GetNumCompanions( creatureType )
	if n == 0 then
		self:AddLine( string.format( "%s: %s", ArkInventory.Global.Location[ArkInventory.Const.Location.Pet].Name, ArkInventory.Localise["LDB_COMPANION_NONE"] ) )
		return
	end
	
	local track = ArkInventory.db.char.option.ldb.pets.track
	
	if track then
		for k = 1, n do
			local creatureID, creatureName, creatureSpellID, texture, active = GetCompanionInfo( creatureType, k )
			if creatureSpellID == track then
				self:AddLine( string.format( "%s: %s", ArkInventory.Global.Location[ArkInventory.Const.Location.Pet].Name, creatureName ) )
				return
			end
		end
	else
		self:AddLine( string.format( "%s: %s", ArkInventory.Global.Location[ArkInventory.Const.Location.Pet].Name, ArkInventory.Localise["RANDOM"] ) )
	end

end

function ArkInventory.LDB.Pets.OnClick( frame, button )

	if button == "RightButton" then
		
		ArkInventory.MenuLDBPetsOpen( frame )
		
	else
		
		if UnitOnTaxi( "PLAYER" ) then return end

		local creatureType = "CRITTER"
		
		if GetNumCompanions( creatureType ) == 0 then return end
		
		local track = ArkInventory.db.char.option.ldb.pets.track
		
		if not track then
			
			local companionTable = { } -- companion table
			-- random mount
			ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable )
			
			if #companionTable == 0 then return end
			
			CallCompanion( creatureType, companionTable[random( 1, #companionTable )] )
			return
			
		else
			
			-- specific pet
			local k = ArkInventory.LDB.Companion.GetSpecific( creatureType, track )
			if k then
				CallCompanion( creatureType, k )
			else
				ArkInventory.OutputError( ArkInventory.Localise["LDB_COMPANION_MISSING"] )
				ArkInventory.db.char.option.ldb.pets.track = nil
			end
			
		end
		
	end
	
end


function ArkInventory.LDB.Mounts:Update( )
	
	self.icon = [[Interface\Icons\INV_Misc_Dice_02]]
	
	local creatureType = "MOUNT"
	
	local track
	
	if IsSwimming( ) then
		track = ArkInventory.db.char.option.ldb.mounts.water.track
	end
	
	if ArkInventory.LDB.Companion.IsFlyable( ) then
		track = ArkInventory.db.char.option.ldb.mounts.flying.track
	else
		track = ArkInventory.db.char.option.ldb.mounts.ground.track
	end
	
	if track then
		local creatureID, creatureName, creatureSpellID, texture, active
		for k = 1, GetNumCompanions( creatureType ) do
			creatureID, creatureName, creatureSpellID, texture, active = GetCompanionInfo( creatureType, k )
			if creatureSpellID == track then
				self.icon = texture
				return
			end
		end
		
	end
	
end

function ArkInventory.LDB.Mounts:OnTooltipShow( )
	
	local creatureType = "MOUNT"
	
	local n = GetNumCompanions( creatureType )
	if n == 0 then
		self:AddLine( string.format( "%s: %s", ArkInventory.Global.Location[ArkInventory.Const.Location.Mount].Name, ArkInventory.Localise["LDB_COMPANION_NONE"] ) )
		return
	end
	
	local track = ArkInventory.db.char.option.ldb.mounts.ground.track
	if IsSwimming( ) then
		track = ArkInventory.db.char.option.ldb.mounts.water.track
	elseif ArkInventory.LDB.Companion.IsFlyable( ) then
		track = ArkInventory.db.char.option.ldb.mounts.flying.track
	end
	
	if track then
		for k = 1, n do
			local creatureID, creatureName, creatureSpellID, texture, active = GetCompanionInfo( creatureType, k )
			if creatureSpellID == track then
				self:AddLine( string.format( "%s: %s", ArkInventory.Global.Location[ArkInventory.Const.Location.Mount].Name, creatureName ) )
				return
			end
		end
	else
		self:AddLine( string.format( "%s: %s", ArkInventory.Global.Location[ArkInventory.Const.Location.Mount].Name, ArkInventory.Localise["RANDOM"] ) )
	end
	
end

function ArkInventory.LDB.Mounts.OnClick( frame, button )
	
	if button == "RightButton" then
		
		ArkInventory.MenuLDBMountsOpen( frame )
		
	else
		
		if ArkInventory.Global.Mode.Combat then return end
		if UnitOnTaxi( "PLAYER" ) then return end
		
		local creatureType = "MOUNT"
		
		if GetNumCompanions( creatureType ) == 0 then return end
		
		if IsMounted( ) then
			
			if IsFlying( ) then
				if not ArkInventory.db.char.option.ldb.mounts.flying.dismount then
					ArkInventory.OutputWarning( ArkInventory.Localise["LDB_MOUNTS_FLYING_DISMOUNT_WARNING"] )
				else
					Dismount( )
				end
			else
				Dismount( )
			end
			
			return
			
		end
		
		local companionTable = { } -- companion table
		
		if IsSwimming( ) then
		
			--ArkInventory.Output( "water mount" )
			
			local track = ArkInventory.db.char.option.ldb.mounts.water.track
			
			if not track then
				
				--ArkInventory.Output( "random" )
				
				ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable, "water" )
				
				if #companionTable == 0 and ArkInventory.LDB.Companion.IsFlyable( ) then  -- no valid water mounts, fallback to flying
					ArkInventory.Output( "fallback to flying" )
					ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable, "flying" )
				end
				
				if #companionTable == 0 then  -- no valid flying mounts, fallback to ground
					ArkInventory.Output( "fallback to ground" )
					ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable, "ground" )
				end
				
				if #companionTable > 0 then
					CallCompanion( creatureType, companionTable[random( 1, #companionTable )] )
					return
				end
				
			else
				
				--ArkInventory.Output( "specific" )
				
				local k = ArkInventory.LDB.Companion.GetSpecific( creatureType, track )
				if k then
					CallCompanion( creatureType, k )
				else
					ArkInventory.OutputError( ArkInventory.Localise["LDB_COMPANION_MISSING"] )
					ArkInventory.db.char.option.ldb.mounts.water.track = nil
				end
				
			end
		
		elseif ArkInventory.LDB.Companion.IsFlyable( ) then
			
			--ArkInventory.Output( "flying mount" )
			
			local track = ArkInventory.db.char.option.ldb.mounts.flying.track
			
			if not track then
				
				--ArkInventory.Output( "random" )
				
				ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable, "flying" )
				
				if #companionTable == 0 then  -- no valid flying mounts, fallback to valid ground mounts
					--ArkInventory.Output( "fallback to ground" )
					ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable, "ground" )
				end
				
				if #companionTable > 0 then	
					CallCompanion( creatureType, companionTable[random( 1, #companionTable )] )
				end
				
			else
				
				--ArkInventory.Output( "specific" )
				
				local k = ArkInventory.LDB.Companion.GetSpecific( creatureType, track )
				if k then
					CallCompanion( creatureType, k )
				else
					ArkInventory.OutputError( ArkInventory.Localise["LDB_COMPANION_MISSING"] )
					ArkInventory.db.char.option.ldb.mounts.flying.track = nil
				end
				
			end
			
		else
			
			--ArkInventory.Output( "ground mount" )
			
			local track = ArkInventory.db.char.option.ldb.mounts.ground.track
			
			if not track then
				
				--ArkInventory.Output( "random" )
				
				ArkInventory.LDB.Companion.GetAvailable( creatureType, companionTable, "ground" )
				if #companionTable > 0 then
					CallCompanion( creatureType, companionTable[random( 1, #companionTable )] )
				end
				
			else
				
				--ArkInventory.Output( "specific" )
				
				local k = ArkInventory.LDB.Companion.GetSpecific( creatureType, track )
				if k then
					CallCompanion( creatureType, k )
				else
					ArkInventory.OutputError( ArkInventory.Localise["LDB_COMPANION_MISSING"] )
					ArkInventory.db.char.option.ldb.mounts.ground.track = nil
				end
				
			end
			
		end
		
	end
	
end


function ArkInventory.LDB.Companion.IsFlyable( )

	local result = IsFlyableArea( )
	
	--ArkInventory.Output( result, " / ", GetRealZoneText( ), " / ", GetWintergraspWaitTime( ) )
	
	if result and GetRealZoneText( ) == ArkInventory.Localise["WOW_ZONE_WINTERGRASP"] and not GetWintergraspWaitTime( ) then
		--ArkInventory.Output( "battle in progress, no flying allowed" )
		result = false
	end
	
	--ArkInventory.Output( result, " / ", GetRealZoneText( ), " / ", " / ", GetWintergraspWaitTime( ) )
	
	return result
	
end

function ArkInventory.LDB.Companion.GetSpecific( creatureType, track )
	
	local n = GetNumCompanions( creatureType )
	for k = 1, n do
		local creatureID, creatureName, creatureSpellID, texture, active = GetCompanionInfo( creatureType, k )
		if creatureSpellID == track then
			return k
		end
	end
	
end

function ArkInventory.LDB.Companion.GetAvailable( creatureType, creatureTable, mountType )
	
	local n = GetNumCompanions( creatureType )
	
	table.wipe( creatureTable )
	
	local count = 0
	for creatureIndex = 1, n do
		
		local creatureID, creatureName, creatureSpellID, texture, active = GetCompanionInfo( creatureType, creatureIndex )
		local creatureData = ArkInventory.Const.CompanionData[creatureSpellID]
		
		if not active and creatureData then
			
			local ok = true
			
			if ok and mountType then
				
				-- speed check for mounts
				
				ok = false
				
				local speed
				if mountType =="ground" then
					speed = creatureData.sg
				elseif mountType =="flying" then
					speed = creatureData.sf
				elseif mountType =="water" then
					speed = creatureData.sw
				end
				
				if speed and ( speed == 0 or speed >= ArkInventory.db.char.option.ldb.mounts[mountType].min ) then
					ok = true
--				else
					--ArkInventory.Output( "ignoring ", creatureName, ", does not meet minimum speed or is not the requested type" )
				end
				
			end
				
			if ok and creatureData.r then
				
				ok = false
				
				-- has a zone based restriction
				local zone = true
				if creatureData.r.zone then
					zone = false
					--ArkInventory.Output( "zone [", creatureData.r.zone, "] == [", GetRealZoneText( ), "]")
					for k in string.gmatch( creatureData.r.zone, "[^,]+") do
						if GetRealZoneText( ) == ( ArkInventory.Localise[k] or "" ) then
							zone = true
							break
						end
					end
--					if not zone then
--						ArkInventory.Output( "ignoring ", creatureName, ", not in correct zone" )
--					end
				end
				
				-- requires an item based reagent
				local item = true
				if creatureData.r.item then
					item = false
					if GetItemCount( creatureData.r.item, false, true ) > 0 then
						item = true
					end
--					if not item then
--						ArkInventory.Output( "ignoring ", creatureName, ", no reagent found" )
--					end
				end
				
				if zone and item then
					ok = true
				else
					--ArkInventory.Output( "restricted ", creatureIndex, " / ", creatureID, " [", creatureName, " ]" )
				end
				
			end
			
			if ok then
				count = count + 1
				creatureTable[count] = creatureIndex
			end
			
		end
		
	end

end
